//EEE3050 Theory on Computer Architectures (Spring 2017)

//Instructor: Prof. Jinkyu Jeong (jinkyu@skku.edu)

//TA: Gyusun Lee(lgs0409@naver.com), Minwoo Ahn(mwahn402@gmail.com)

//Semiconductor Building #400509

//Author: Minwoo Ahn

//Copyright (c) 2017 SungKyunKwan Univ. CSL(Computer Systems Laboratory)

#ifndef __mem__
#define __mem__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct cache_entry {
	char valid;
	int tag;
	int dirty;
	char **data;
	/* You can add variables for your purpose  */

};

struct cache {
	struct cache_entry **way_cache;
	int num_entry;
	int num_ways;
	int bytes_per_block;	// # of bytes / block
	int block_per_entry; 	// # of block / entry
};

struct cache cache;
char memory[1024 * 1024 * 256][4];

char *read_op(int);
void write_op(int, char *);

/* Flush data in cache to disk*/
void flush(int, int);
void print_cache(FILE *);
int hw3_check(void);

/* Initialization before start simulation. */
void initialize(void);
/* Destroy after simulation*/
void destroy(void);

#endif
